/*
 * Copyright 1995, 1998 Perforce Software.  
 *
 * This file is part of WebKeeper, a perforce client apache module.
 *
 * License is hereby granted to use this software and distribute it
 * freely, as long as this copyright notice is retained and modifications
 * are clearly marked.
 *
 * ALL WARRANTIES ARE HEREBY DISCLAIMED.
 *
 * $Id: //guest/paul_goffin/apache1.3.6/src/modules/perforce/mod_webkeep.h#2 $
 */

/*
 * webkeep.h - glue mod_webkeep.c to the Perforce api via webkeep.cc
 *
 * This header file is for inclusion by mod_webkeep.c when building
 * webkeeper into an Apache web server.
 */

typedef struct _WebKeepPrinter WebKeepPrinter;
typedef struct _WebKeepConnect WebKeepConnect;

/*
 * WebKeepConnect - pointers to configuration data stored by Apache
 */

struct _WebKeepConnect {

    char *port;                 /* WebKeepPort - default $P4PORT,
                                   perforce:1666 */ 
    char *user;                 /* WebKeepUser - default $P4USER,
                                   $USERNAME */ 
    char *pass;                 /* WebKeepPasswd - no default */ 
    char *client;               /* WebKeepClient - default $P4CLIENT,
                                   hostname */ 
    char *indexname;		/* filename to look for to use
				 * as an index (default index.html) */

} ;

/*
 * webkeepprinter - callbacks to Apache code
 */

struct _WebKeepPrinter {

    void *closure;              /* original request */

    /* flags */
    int ignoreerrors;
    int collectinfo;            /* building directory */
    int print;                  /* printing file */

    /* counters */
    int errorcount;

    /* directories and files (for directrory listing) */
    void *files;
    void *dirs;

    /* callbacks */
    void (*data)(WebKeepPrinter *, 
                 const char *); /* info text */
    void (*text)(WebKeepPrinter *, 
                 char *, int);  /* text & length */
    void (*dir)(WebKeepPrinter *); /* directory dump */
    void (*error)(WebKeepPrinter *, 
                  char *);      /* text only */
  
} ;

# ifdef CPLUSPLUS
extern "C" {
# endif

int webKeepPrint(WebKeepConnect *p4, const char *path, 
                 WebKeepPrinter *printer); 

# ifdef CPLUSPLUS
}
# endif

